// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class ConvertNode extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    start () {

    }

    // update (dt) {}

    convertNode(node: cc.Node){
        let debugNode = this.node;
        cc.error("--------------------------------------------------------");
        while (debugNode) {
            let worldPos = node.convertToWorldSpaceAR(cc.Vec2.ZERO);
            let pos = debugNode.convertToNodeSpaceAR(worldPos);
            cc.error("winPos node-%s:", debugNode.name, this.node.position.toString());
            cc.error("beginPos:%s, worldPos:%s, endPos:", node.position.toString(), worldPos.toString(), pos.toString());
            debugNode = debugNode.parent;
        }
        cc.error("--------------------------------------------------------");
        let worldPos = node.convertToWorldSpaceAR(cc.Vec2.ZERO);
        let pos = this.node.convertToNodeSpaceAR(worldPos);
        node = cc.instantiate(node);
        node.setParent(this.node);
        node.setPosition(pos);
    }
}
